<?php

class OPTIONS {
 var $options;
    
 function __construct(&$req = NULL, &$override = NULL) {
    global $OPTIONS;

    if ($req instanceof REQUEST) $props = &$req->props;
    else $props = &$req;
    
    $this->options = array();
    if ($override) $this->options[] = &$override;
    
    if (($req)&&(isset($props['db_server']))) {
	$sname = $props['db_server']; $slen = strlen($sname);
	
	if (isset($props['db_name'])) {
	    $dname = "__" . $props['db_name']; $dlen = strlen($dname);

	    if (isset($props['db_group'])) {
	        $gname = $props['db_group'];
	    }
	}

	foreach (array_keys($OPTIONS) as $regex) {
	    if (!strncmp($regex, $sname, $slen)) {
		$len = strlen($regex);
		if ($len == $slen) $sopts = &$OPTIONS[$regex];
		elseif (($dname)&&(!strcmp(substr($regex, $slen, $dlen), $dname))) {
		    $pos = strpos($regex, "__", $slen + $dlen);

		    if ($pos === false) $dopts = &$OPTIONS[$regex];
		    else if (($gname)&&(!strcmp(substr($regex, $pos + 2), $gname))) {
			$gopts = &$OPTIONS[$regex];
			if (($sopts)&&($dopts))	break;
		    }
		}
	    }
	}
	
	if ($gopts) $this->options[] = &$gopts;
        if ($dopts) $this->options[] = &$dopts;
	if ($sopts) $this->options[] = &$sopts;
    }
    if (isset($OPTIONS['default'])) $this->options[] = &$OPTIONS['default'];
 }
 
 function Get($prop, $default=NULL) {
    foreach ($this->options as &$opts) {
	if (isset($opts[$prop])) return $opts[$prop];
    }
    return $default;
 }


 function GetDateLimit($default_from = false, $default_to = false) {
    $date_limit = $this->Get('date_limit');
    if ($date_limit) {
	if (is_array($date_limit)) {
	    if (is_int($date_limit[0])) $start_date = $date_limit[0];
	    else $start_date = strtotime($date_limit[0]);
	    if (is_int($date_limit[1])) $end_date = $date_limit[1];
	    else $end_date = strtotime($date_limit[1]);
	} else {
	    if (is_int($date_limit)) $start_date = $date_limit;
	    else $start_date = strtotime($date_limit);
	    $end_date = $default_to;
	}
    } else {
	if (is_string($default_from))
	    $start_date = strtotime($default_from);
	else 
	    $start_date = $default_from;
	$end_date = $default_to;
    }

    return array($start_date, $end_date);
 }

}


?>