<?php
/*
$config = array (
    "db_server" => "katrin", 
    "db_name" => "hauptspektrometer"
);
*/

/*
function signal_handler($signal) {
    profilerDisplay();
    exit;
}
declare(ticks = 1);
pcntl_signal(SIGINT, "signal_handler");
*/

$res = exec('ps xa | grep "cache.php" | grep -v grep | wc -l');
if ($res > 1) exit;

if (preg_match("/(.*)cache.php$/", $_SERVER['SCRIPT_FILENAME'], $m)) @chdir($m[1]);

require("../adei.php");
#adeiLogOutput();


function ROOTCache(&$cache, $rootdb, $app, $inq_app, $rootdb_name) {
    try {

	$desc = array(
	    0 => array("pipe", "r"),
	    1 => array("pipe", "w"),
	    2 => array("pipe", "w")
	);

	$cmd = proc_open($inq_app, $desc, $pipes);
	if ($cmd) {
	    if ($rootdb) {
	        fwrite($pipes[0], $rootdb['user'] . "\n");
		fwrite($pipes[0], $rootdb['password'] . "\n");
	    }
	    fclose($pipes[0]);

	    $start = stream_get_contents($pipes[1]);
	    fclose($pipes[1]);
	    
	    $errors = stream_get_contents($pipes[2]);
	    $ret = proc_close($cmd);
	    if ($ret) throw new ADEIException("Execution of csv2root is finished with error code $ret");

	} else throw new ADEIException("Execution of csv2root is failed");
	
	if ($start < 0) $start = 0;

	$ivl = $cache->CreateInterval();
	$ivl->Limit($start);

	$cmd = popen($app, "w");
	if ($rootdb) {
	    fwrite($cmd, $rootdb['user'] . "\n");
	    fwrite($cmd, $rootdb['password'] . "\n");
	}
	$cache->ExportCSV(new STREAMOutput($cmd), $mask = NULL, $ivl);
	if ($err = pclose($cmd)) throw new ADEIException("csv2root is finished with error: $err");
    } catch(ADEIException $e) {
	$e->logInfo(translate("Problem processing ROOT database \"%s\"", $rootdb_name), $cache);
	echo "Problem processing ROOT database \"" . $rootdb_name . "\": " .  $e->getInfo() . "\n";
    }
}

function DoCache(&$req) {
    global $ROOT_DB;

    try {
	$reader = $req->CreateReader(REQUEST::READER_FORBID_CACHEREADER);
    } catch(ADEIException $e) {
	if ($e->getCode() == ADEIException::DISCONNECTED) return;

	$e->logInfo(translate("READER constructor is failed"), $req);
        return $req->GetLocationString() . ", Error: " . $e->getInfo();
    }

    try {
        $opts = &$req->GetOptions();
	$rootdb = $opts->Get('root_database');

	$list = $req->GetGroups($reader);
    } catch(ADEIException $e) {
	$e->logInfo(translate("Problem processing options"), $reader);
        return $req->GetLocationString() . ", Error: " . $e->getInfo();
    }

    if ($rootdb) {
	if (strchr($rootdb, "/")) {
	    $db_info = false;
	    $inq_app = adei_app("csv2root", "--file " . $rootdb . " --inquiry-latest-data", true);
	    $app = adei_app("csv2root", "--file " . $rootdb, true);
	} else {
	    try {
		$db_info = $ROOT_DB;
		$db_info['database'] = $rootdb;
		$database = new DATABASE($db_info);
	    } catch (ADEIException $e) {
		unset($db_info['database']);
		try {
		    $database = new DATABASE($ROOT_DB);
		    $database->CreateDatabase($rootdb);
		} catch(ADEIException $e) {
		    $e->logInfo(translate("Problem accessing ROOT database \"%s\"", $rootdb), $req);
		    echo translate("Problem accessing ROOT database \"%s\": %s\n", $rootdb, $e->getInfo());
		    $rootdb = false;
		}
	    }

	    if ($rootdb) {
		$conprm = $db_info['driver'] . "://" . $db_info['host'] . ($db_info['port']?(":" . $db_info['port']):"") . "/" . $rootdb;
		$inq_app = adei_app("csv2root", "--db " . $conprm . " --inquiry-latest-data", true);
		$app = adei_app("csv2root", "--db " . $conprm, true);
	    }
	}
	if ($rootdb) {
	    if ((!$app)||(!$inq_app)) {
		echo("csv2root is not present");
		$rootdb = false;
	    } else {
	        $groups = $reader->GetGroupList(REQUEST::NEED_INFO);
	    }
	}
    }

    foreach ($list as $gid => $greq) {
	try {
	    $cache = $greq->CreateCacheUpdater($reader);
	    $cache->Update();
	    
	    if ($rootdb) {
		$grname = " --group \"" . $groups[$gid]["name"] . "\"";
		ROOTCache($cache, $db_info, $app . $grname, $inq_app . $grname, $conprm?$conprm:$rootdb);
	    }
	    unset($cache);
	} catch(ADEIException $e) {
	    if ($e->getCode() !=  ADEIException::DISABLED) {
		$e->logInfo(translate("Failed to update CACHE"), $cache?$cache:$greq);
		return $greq->GetLocationString() . ", Error: " . $e->getInfo();
	    }
	}
    }
    
    return 0;
}

$req = new REQUEST($config);
$list = $req->GetSources();

foreach ($list as $sreq) {
    $err = DoCache($sreq);
    if ($err) echo "$err\n\n\n";
}
?>